/* _bsyflag.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Subroutines for correct creation   ணࠬ ४⭮ ᮧ   -
 * and deleting .bsy files.	      ࠭ 䠩 .bsy.
 *
 * Assumes, that we need  only	ONE   ࠧ㬥,     ६-
 * such file every time. It is eno-     㦥 ஢  ⠪ 䠩. ⮣
 * ugh for tosser.		      筮  .
 *
 * DO NOT use this routines in mul-    ᯮ  ணࠬ  -
 * tiline mailer's! They are  simp-       !    
 * lified to tosser task, and using   ᯮ 䨪஢	  ६
 * fixed name for temporary files.    䠩!
 *
 * bsy_create():
 * returns 0 if success
 * returns -1 if not success
 *
 * bsy_remove():
 *
 * returns 0 if successful		     0  ᯥ
 * returns -1 if close returns -1	    -1  close.
 *
 */

#ifndef _BSYFLAG_C
#define _BSYFLAG_C

#if (defined(UNIX) && (!defined(__EMX__)))
#include <sys/file.h>
#define ClearRO(A)

#elif (defined(__EMX__))
#include <sys/file.h>
#define ClearRO(A)

#elif (defined(__TURBOC__))

#define ClearRO(A) chmod(A, S_IFREG | S_IWRITE)

#include <dos.h>

#else

#define ClearRO(A)

#endif

static	char	pathname_bsy[MAXPATH+1];	/* pathname of bsy flag */
static	char	pathname_tmp[MAXPATH+1];	/* pathname to tmp file */

int bsy_create(void);
int bsy_remove(void);

#if ((defined(UNIX) && (!defined(__EMX__))) || ((defined(LOCK_EX)) && (defined(LOCK_UN))))

static	int	handle = -1;			/* flocked file handle	*/

int bsy_create()
{
unlink(pathname_tmp);
handle = open(pathname_tmp, O_CREAT | O_EXCL);
if (handle == -1) return -1; else;
if (flock(handle,LOCK_EX) == -1)
	{
	close(handle);
	return -1;
	}
else;
if (link(pathname_tmp,pathname_bsy))
     {				/* not success link			  */
Not_Success:
     flock(handle,LOCK_UN);	/* unlock				  */
     unlink(pathname_tmp);	/* remove temporary file		  */
     return -1;
     }
else {				/* success link?			  */
     struct stat f1, f2;
     if ((!stat(pathname_tmp, &f1)) &&		/* Really success only if */
	 (!stat(pathname_bsy, &f2)) &&		/* inodes of two files are*/
	 (f1.st_ino == f2.st_ino))		/* identical!		  */
	 {
	 unlink(pathname_tmp);	    /* Delete tmp file			  */
	 return 0;
	 }
     else goto Not_Success;
     }
}

int bsy_remove()
{
unlink(pathname_tmp);
if(link(pathname_bsy, pathname_tmp))
     {				/* not success link  - may be not our BSY */
				/* or our, but someway crashed		  */
     if (handle != -1) close(handle); else;
     flock(handle, LOCK_UN);	/* unlock handle not to add problems...   */
     return -1; 		/* Uncorrectable error in bsy removing... */
     }
else {				/* success link */
     unlink(pathname_bsy);	/* Delete BSY */
     unlink(pathname_tmp);	/* Delete tmp */
     flock(handle, LOCK_UN);	/* Unlock handle */
     if (handle != -1) close(handle); else;
     return 0;
     }
}
#elif RENAME_NONDESTRUCTIVE	/* constant created by HASHER if tested    */
				/* Note, that is is 'rename' logic! No     */
				/* locked handle is between create and re- */
				/* move actions.			   */
#if !RENAME_CHECKEXIST
int bsy_create()
{
creatnew(pathname_tmp, 0);			/* Create temporary file   */
if (rename(pathname_tmp,pathname_bsy) == RENAME_ERROR)

						/* Check rename 	   */
     {						/* unsuccess - not our bsy */
     unlink(pathname_tmp);			/* delete temporary file   */
     return -1;
     }
else return 0;					/* success		   */
}
#else /* !RENAME_CHECKEXIST */
int bsy_create()
{
struct stat f;
creatnew(pathname_tmp, 0);			/* Create temporary file   */
rename(pathname_tmp,pathname_bsy);
if ((stat(pathname_tmp, &f)) && (!stat(pathname_bsy, &f))) return 0;
else {
     unlink(pathname_tmp); return -1;
     }
}
#endif /* else !RENAME_CHECKEXIST */

int bsy_remove()
{
return (unlink(pathname_bsy));
}

#else /* !UNIX || __EMX__ || !RENAME_NON_DESTRUCTIVE */
#error I has no idea for 'No flock, no lockf, rename is destructive'
#endif

#endif /* _BSYFLAG_C */
/* EOF _bsyflag.c */
