/* _debug.c * Content-Type: TEXT/PLAIN; charset=cp866
 ******************************************************************************
 * Debug printing function for mac-   㭪 ⫠筮   ᯮ짮-
 * ros Debug using. Written by	Cy-      Debug. ᠭ ஬  -
 * ril Slobin.			      .
 *
 * Practical usage:						 ᯮ짮:
 *		    Debug("Just a message");
 *		    Debug("i = %i", i);
 *		    Debug("Buffer = \"%s\", i = %i", Buffer, i);
 * Result output:						     :
 *		    File sqwish.c, Line 12: Just a message
 *		    File sqwish.c, Line 13: i = 0
 *		    File sqwish.c, Line 14: Buffer = "", i = 0
 * ------------------------------------------------------------------------- */


/*
 * Additional debug function.         ⥫쭠 ⫠筠 㭪.
 */

void askwait()
{
fprintf(stderr,"\nDebug: Press any key to exit from SqWish>");
getchar();
}

#if (defined(VA_DISABLE))
/*
 * If compiler doesn't work correct   ᫨   ࠡ⠥  ४⭮  
 * with va_list components (descri-   ⠬ va_list (ᠭ묨  䠩
 * bed in stadrg.h or in varargs.h)   stdarg.h  varargs.h) - hasher.exe  -
 * hasher.exe  adds  definition  of    । VA_DISABLE 	sqw-cfg
 * VA_DISABLE  to  sqw-cfg.h to use    ⮣, ⮡ ᯮ짮 񭭠
 * more simple _debug version. ANSI    _debug. ANSI     -
 * C MUST have correct va_list com-   ४    va_list,    
 * ponents, but at  least  MS C 6.0   ࠩ    6.0  ஡-
 * has some troubles with it.	         ᯮ짮.
 *
 * It's actual only if DEBUG is 1.    㠫쭮  ⮫쪮 ᫨ DEBUG == 1.
 * ------------------------------------------------------------------------- */

void (*_debug(const char *file, int line))(const char *format,...)
{
printf("\nFile %s, line %d: ", file, line);
return printf;
}

#else

/*
 * Debug function itself
 *
 *
 *
 */

#include <stdarg.h>

static void _debug2(const char *format,...)
{
va_list va_ptr_here; int Nn = 0;
va_start(va_ptr_here, Nn);
vprintf (format, va_ptr_here);
va_end(va_ptr_here);
printf ("\n");
}

void (*_debug(const char *file, int line))(const char *format,...)
{
printf("File %s, line %d: ", file, line);
return _debug2;
}
#endif /* else (defined(VA_DISABLE)) */

