/* content.c */
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#include "..\unix\_match.c"

/*
 * DOS ONLY programm!!! (setmode causes OS-aware results in THIS programm)
 * Conversion of koi/unix-style source to 866/dos-style and vise versa
 * due to line Content-Type in file encountered.
 */

static unsigned int tab1[128] =
{
/*   -> dos */
0xC4, 0xB3, 0xDA, 0xBF, 0xC0, 0xD9, 0xC3,
0xB4, 0xC2, 0xC1, 0xC5, 0xDF, 0xDC, 0xDB, 0xDD, 0xDE, 0xB0, 0xB1, 0xB2, 0x00, 0xFE, 0xF9, 0xFB,
0x00, 0x00, 0x00, 0xFF, 0x00, 0xF8, 0x00, 0xFA, 0x00, 0xCD, 0xBA, 0xD5, 0xF1, 0xD6, 0xC9, 0xB8,
0xB7, 0xBB, 0xD4, 0xD3, 0xC8, 0xBE, 0xBD, 0xBC, 0xC6, 0xC7, 0xCC, 0xB5, 0xF0, 0xB6, 0xB9, 0xD1,
0xD2, 0xCB, 0xCF, 0xD0, 0xCA, 0xD8, 0xD7, 0xCE, 0x63, 0xEE, 0xA0, 0xA1, 0xE6, 0xA4, 0xA5, 0xE4,
0xA3, 0xE5, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF, 0xEF, 0xE0, 0xE1, 0xE2, 0xE3, 0xA6,
0xA2, 0xEC, 0xEB, 0xA7, 0xE8, 0xED, 0xE9, 0xE7, 0xEA, 0x9E, 0x80, 0x81, 0x96, 0x84, 0x85, 0x94,
0x83, 0x95, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F, 0x9F, 0x90, 0x91, 0x92, 0x93, 0x86,
0x82, 0x9C, 0x9B, 0x87, 0x98, 0x9D, 0x99, 0x97, 0x9A
};

static unsigned int tab2[128] =
{
/*   ८ࠧ dos -> koi */
0xE1, 0xE2, 0xF7, 0xE7, 0xE4, 0xE5, 0xF6,
0xFA, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0, 0xF2, 0xF3, 0xF4, 0xF5, 0xE6, 0xE8, 0xE3,
0xFE, 0xFB, 0xFD, 0xFF, 0xF9, 0xF8, 0xFC, 0xE0, 0xF1, 0xC1, 0xC2, 0xD7, 0xC7, 0xC4, 0xC5, 0xD6,
0xDA, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0, 0x90, 0x91, 0x92, 0x81, 0x87, 0xB2, 0xB4,
0xA7, 0xA6, 0xB5, 0xA1, 0xA8, 0xAE, 0xAD, 0xAC, 0x83, 0x84, 0x89, 0x88, 0x86, 0x80, 0x8A, 0xAF,
0xB0, 0xAB, 0xA5, 0xBB, 0xB8, 0xB1, 0xA0, 0xBE, 0xB9, 0xBA, 0xB6, 0xB7, 0xAA, 0xA9, 0xA2, 0xA4,
0xBD, 0xBC, 0x85, 0x82, 0x8D, 0x8C, 0x8E, 0x8F, 0x8B, 0xD2, 0xD3, 0xD4, 0xD5, 0xC6, 0xC8, 0xC3,
0xDE, 0xDB, 0xDD, 0xDF, 0xD9, 0xD8, 0xDC, 0xC0, 0xD1, 0xB3, 0xA3, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x9C, 0x95, 0x9E, 0x96, 0x00, 0x00, 0x94, 0x9A
};

static unsigned char Buffer[32767];
static unsigned char Mask1[] = "*Content-Type: TEXT/PLAIN; charset=koi8-r\n";
static unsigned char Mask2[] = "*Content-Type: TEXT/PLAIN; charset=cp866\n";

static where_to_code = 0;

void main()
{
unsigned int tab11[256];
unsigned int tab22[256];
int c;

for (c = 0; c < 128; c++) tab11[c] = tab22[c] = c;
for (c = 128; c < 256; c++) tab11[c] = tab1[c-128];
for (c = 128; c < 256; c++) tab22[c] = tab2[c-128];

while (fgets(Buffer, 32767, stdin))
	{
	unsigned char *s0 = Buffer;
	if (!strcasecmp_match(Buffer, Mask1))
		{
		where_to_code = 1;
		s0 = Buffer + strlen(Buffer) - 7;
		strcpy (s0, Mask2 + 35);
		}
	else if (!strcasecmp_match(Buffer, Mask2))
		{
		setmode(fileno(stdout), O_BINARY);
		where_to_code = 2;
		s0 = Buffer + strlen(Buffer) - 6;
		strcpy (s0, Mask1 + 35);
		}
	else switch(where_to_code)
		{
		case 1:	do *s0 = (char)tab11[(unsigned int)*s0]; while (*s0++); break;
		case 2:	do *s0 = (char)tab22[(unsigned int)*s0]; while (*s0++); break;
		default:;
		} /* switch where_to_code */
	fputs(Buffer, stdout);
	} /* while fgets */
} /* main */
