/* makeunix.c */
#include <stdio.h>

#define LENGTH 8192

static unsigned int tab2[128] =
{
/* dos -> koi */
0xE1, 0xE2, 0xF7, 0xE7, 0xE4, 0xE5, 0xF6, 0xFA,
0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0,
0xF2, 0xF3, 0xF4, 0xF5, 0xE6, 0xE8, 0xE3, 0xFE,
0xFB, 0xFD, 0xFF, 0xF9, 0xF8, 0xFC, 0xE0, 0xF1,
0xC1, 0xC2, 0xD7, 0xC7, 0xC4, 0xC5, 0xD6, 0xDA,
0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0,
0x90, 0x91, 0x92, 0x81, 0x87, 0xB2, 0xB4, 0xA7,
0xA6, 0xB5, 0xA1, 0xA8, 0xAE, 0xAD, 0xAC, 0x83,
0x84, 0x89, 0x88, 0x86, 0x80, 0x8A, 0xAF, 0xB0,
0xAB, 0xA5, 0xBB, 0xB8, 0xB1, 0xA0, 0xBE, 0xB9,
0xBA, 0xB6, 0xB7, 0xAA, 0xA9, 0xA2, 0xA4, 0xBD,
0xBC, 0x85, 0x82, 0x8D, 0x8C, 0x8E, 0x8F, 0x8B,
0xD2, 0xD3, 0xD4, 0xD5, 0xC6, 0xC8, 0xC3, 0xDE,
0xDB, 0xDD, 0xDF, 0xD9, 0xD8, 0xDC, 0xC0, 0xD1,
0xB3, 0xA3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x9C, 0x95, 0x9E, 0x96, 0x00, 0x00, 0x94, 0x9A
};

static unsigned char Mask1[] = "Content-Type: TEXT/PLAIN; charset=koi8-r\n";
static unsigned char Mask2[] = "Content-Type: TEXT/PLAIN; charset=cp866\n";

static where_to_code = 0;

FILE *fin, *fout;
unsigned char Buffer[LENGTH+1], *s0, *s1, *s2, fname[LENGTH+1];
unsigned int tab22[256];
int c, i, j, c0;

int Get_Line(int tab)
{
s0 = Buffer;
j = 0;
do	{
   	if ((c = fgetc(fin)) == EOF) break; else;
   	if (c == '\r') continue; else;
   	if (!tab) *s0++ = (char)c; else *s0++ = (char)tab22[c];
   	j++;
   	}
while((c != '\n') && (j < LENGTH));
*s0 = '\0';
return (c != EOF);
}

void main(int argc, char **argv)
{

for (c = 0; c < 128; c++) tab22[c] = c;
for (c = 128; c < 256; c++) tab22[c] = tab2[c-128];

if (argc <= 2)
	{
	puts("Utility to convert Content-type marked texts from DOS to UNIX");
	puts("Usage:");
	puts("makeunix dirout/ filein");
	puts("Errorlevels:");
	puts("0 - Success; 1 - not enough command line;");
	puts("2 - no file; 3 - Can't open output file or I/O error");
	exit(1);
	}
else;

#if (defined(UNIX) || (!defined(__TURBOC__)))
mkdir(argv[1],0777);
#define BACKSLASH '/'
#else
mkdir(argv[1]);
#define BACKSLASH '\\'
#endif

fputs(argv[1], stdout); fputs("<-",stdout);
strcpy(fname,argv[1]);
s1 = fname + strlen(fname);

c0 = '(';
for (i =  2; i < argc; i++)
   {
   if (argc > 2) putc(c0,stdout); else;
   c0 = ',';
   j = strlen(argv[i]);
   s2 = argv[i] + j;
   while ((j-- > 0) && (*s2 != BACKSLASH)) s2--; /* cut filename only */
   if (*s2 == BACKSLASH) s2++;
   fputs(s2,stdout);
   strcpy(s1,s2);		/* Now fname contains full outfile name */
   fin = fopen(argv[i],"rt");
   if (fin == NULL) exit(2); else;
   Get_Line(0);
   if  ((j < strlen(Mask2)) ||
	(strcmp(Buffer + j - strlen(Mask2), Mask2)))
	{
	rewind(fin);
	fout = fopen(fname,"wt");
	if (fout == NULL) exit(3); else;
	while(Get_Line(0)) fputs(Buffer,fout);
	}
else	{
	if (freopen(argv[i],"rt",fin) == NULL) exit(2); else;
	fout = fopen(fname,"wb");
	if (fout == NULL) exit(3); else;
	Get_Line(1);
	s0 = Buffer + strlen(Buffer) - 6;
	strcpy (s0, Mask1 + 34);
	do fputs(Buffer,fout); while(Get_Line(1));
	} /* else strcmp(Buffer, Mask2) */
   if (ferror(fin) || ferror(fout)) exit(3);
   else { fclose(fin); fclose(fout); }
   } /* for i < argc */
if (argc > 2) putc(')',stdout); else;
putc('\n', stdout);
exit(0);
} /* main() */
