/* sqw-def.h * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Global definitions' file.            ।.
 * Except OS-aware part!	      ஬ -ᨬ !
 *
 */

#ifndef SQW_DEF_H
#define SQW_DEF_H

/************************ Global compiling switching parameters ************
 * Note! Version definition is mo-
 * ved to ../../!version file.
 * ----------------------------------------------------------------------- */

#define SQW_PRODCODE 254/*  prodcode   		   */
#define SQW_PRODCOD2 0	/* ஥  prodcode   	   */

/* ------------------------------------------------------------------------- *
 * 0 - Keep, do not convert 0x8D.     ࠭,  ஢ 0x8D.
 * 1 - Keep in transit, 0x8D->'H'     ࠭  ࠭,   'H' 
 *     in generated messages.	      ᮧ ஬ ᮮ饭.
 * ------------------------------------------------------------------------- */
#define SOFTCR_TO_H 1

/* ------------------------------------------------------------------------- *
 * 0 - no AREAFIX functions.	      ॠ 몫祭 
 * 1 - sqafix.cfg-style syntax	      ⨫ 䨣 sqafix'a
 * ------------------------------------------------------------------------- */
#define AREAFIX_STYLE 0

/* ------------------------------------------------------------------------- *
 * 1 - To: AREAFIX in echomail.       㦨 쬠  AREAFIX'y  .
 * (independent to previous).	      (ᨬ  ।饣).
 * ------------------------------------------------------------------------- */
#define AREAFIX_IN_ECHOES 1

/* ------------------------------------------------------------------------- *
 * Keyword Include works?	      ⠥  祢 ᫮ Include?
 * ------------------------------------------------------------------------- */
#define INCLUDE 1

#ifdef UNIX
/* ------------------------------------------------------------------------- *
 * If this parameter is 1 -  no own   ᫨ 1 -  ࠡ  ᮡ⢥ 䠩-
 * log file format is in UNIX  ver-     UNIX ᨨ -  ᯮ  ⮫쪮
 * sion -  syslog functions may  be   㭪樨 syslog. ஡ - . sqw-log.c
 * only used for logging.
 * ------------------------------------------------------------------------- */
#define SYSLOGONLY 0
#else
#define SYSLOGONLY 0 /* this line must NOT be changed */
#endif

/* ------------------------------------------------------------------------- *
 * If 0 -  DupeChecking  is  Search   ᫨ 0 - ஢ઠ 㯮  ⮫쪮
 * only, no table check; this gives   ᪮,  ⠡筮  㯮.  
 * you additional ~3400 free  bytes   ᢮ 3400  ᯮ塞 -
 * of executed code.		      .
 * ------------------------------------------------------------------------- */
#define DUPETABLE 0

/* ------------------------------------------------------------------------- *
 * If 0 - memory blocks aren't fre-   ᫨ 0 -     ᢮,
 * ed when not needed.	First 1 was    ⠭ 㦭묨. ࢮ砫-
 * debug-only state, I hope to free    ﭨ 1 뫮  ⮫쪮  ⫠.
 * all malloced properly. ;-)	      , ᥩ   ᥡ ...
 * ------------------------------------------------------------------------- */
#define MEMORY_FREE 1

/************************ Some useful OS-independent filenames constants ***
 * Length of filenames	be  created     ᮧ SqWish' 䠩-
 * by SqWish (limited by FTS on PKT    (। ࠭祭ﬨ FTS 
 * files and outbound structures).    䠩 .PKT  ࠬ ⡠㭤).
 *
 * Maximal length of  analyzed	PKT    - ᨬ쭠   -
 * names in inbound directory, too.   㥬 室 .PKT 䠩.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
#define LENNAME  8
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
Number of symbols after last dot in   ᫮ ᨬ ᫥ ᫥ 窨 
filename.ext for created by  SqWish   䠩.ext   ᮧ ணࠬ-
files.				       䠩.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
#define LENEXT	 3

/*****************************************************************************
 * Seen-by and PATH line limit.       ࠭祭  ப seen-by  path.
 *---------------------------------------------------------------------------*/
#define KLUDGE_MAXLEN 62

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
Maximal path  increasing  value  by   ᨬ쭮    
Bink-Style OutBound structure.	        BSO
 *		    .007   / 139C007A.PNT     / 00000023.DLO	  ./././   */
#define MAXADDPATH (LENEXT + LENNAME + LENEXT + LENNAME + LENEXT + 7)

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
 * Maximum depth of Include files.    ᨬ쭠 㡨  Include.
 * DO NOT set it more than 254!        ⠭  254!
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
#define MAXDEPTH 16

/* --------------------- bit masks in AreaLink table --------------------- */
/* These three masks can't be changed - see sqw-cr.c, tabAL[]              */
#define ALIS 1		/* Link addresse existance in EchoArea line	   */
#define ALWO 2		/* Indicate this link WO status for this echoarea  */
#define ALRO 4		/* Indicate this link RO status for this echoarea  */

#define ALTW 8		/* turn off TwitFixing for this link in echoarea   */
			/* (By NoTwitArea option)			   */
#define ALTU 16 	/* turn off TwitUUE for this link in this echoarea */
			/* (By NoTwitUUE option)			   */
#define ALIC 32 	/* Change of ALIS status when AREAFIXing	   */
#define ALAD 128	/* 1 cause add seen-by of this link in echo msgs   */
/* Temporary created from ALRO/ALWO/ALIS masks: - - - - - - - - - - - - -  */
#define ALDN 32 	/* Link receives this echoarea			   */
#define ALUP 64 	/* Link may send messages to this echoarea	   */
/* ----------------------------------------------------------------------- */

enum pointsecure {
		PSE_NO =  0,	/* No checking address in origin line	   */
		PSE_ADDR,	/* Checking address in origin line only    */
		PSE_CHECK_ALL,	/* Checking address, origin, tearline	   */
		PSE_SEEN_PATH	/* Add checking SEEN-BY, PATH lines	   */
		 };

/* --------- LogLevel Information ------------------------------------- */
enum log_level	{
		LEV_ABORT,
		LEV_LOOSE,
		LEV_POSSIBLE,
		LEV_USEFUL,
		LEV_WARN,
		LEV_START,
		LEV_TRIV
		};

/* Partial address analysing	  筮 	*/
enum here_addr	 {
		HERE_EOL = -1,		/*  ப 		*/
		HERE_NOADDR = 0,	/*  ७		*/
		HERE_LINK = 1,		/* 㭫			*/
		HERE_PLUS = 2,		/*  ᨭ		*/
		HERE_P = 3,		/*  -p			*/
		HERE_X = 4,		/*  -x			*/
		HERE_MINUSU,		/*  -u			*/
		HERE_ZERO,		/*  -0			*/
		HERE_DOLLAR,		/*  -$			*/
		HERE_DOLLAR_M,		/*  -$m			*/
		HERE_DOLLAR_D,		/*  -$d			*/
		HERE_DOLLAR_S,		/*  -$s			*/
#if 0
		HERE_G, 		/*  -g  㯯 ॠ䨪 */
#endif /* 0 */
		 };

#define DUPSTEP  100	/* ⢮ "ꥤ"  1   㯮*/
#define MINSEENBY 16384 /*  ࠧ   SEEN-BY  PATH    */
#define MAXTAGLEN 90	/* ࠭祭  ⠣			   */

/*
 * Limit size of files lan_???.cfg   ࠭稢 ࠧ 䨣樮 䠩-
 * to prevent generation  of great    lan_???.cfg   ।饭 -
 * number of messages from garbage   樨 ஬  ᮮ饭  -
 * file. Cause larger files to be    . SqWish ⠥ 訥 䠩 "-
 * 'unseen' for SqWish. In bytes.    묨".  .
 */
#define MAXCFGSIZE 16384 /* ࠭祭  䠩 ⥪⮢ .cfg	   */

#define SQW_BAUD 0	/*  baud    		   */
#define SQW_CAPVALID 256/* ᫮ capability   , ᢠ⮥ */
#define SQW_CAPWORD  1	/* ᫮ capability   		   */

/* ===================== Errorlevels of SqWish.exe: ====================== */
#define Erl_Success 0	/* Nothing to do or Success all done		   */
enum errorlevels {
	Erl_Unknown=129,/* 129 Any error, without distinguishing	   */
	Erl_Config,	/* 130 Error open/reading config		   */
	Erl_Syntax,	/* 131 Syntax error in config			   */
	Erl_MemoryCFG,	/* 132 Error Memory allocation in config reading   */
	Erl_Memory,	/* 133 Error Memory allocation anywhere 	   */
	Erl_Read,	/* 134 Error reading inbound PKTs		   */
	Erl_Write,	/* 135 Error writing outbound packets		   */
	Erl_RunExit,	/* 136 Error executing RunExit line		   */
	Erl_Ren,	/* 137 Error renaming process			   */
	Erl_Directory,	/* 138 Error creating some directories		   */
/* - - - - - - - - - - - - Internal algorythmic errors: - - - - - - - - -  */
	Erl_Tab_Int=198,/* 198 Tabs crashed				   */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
};
/******************** Some buffers' sizes *********************************/
#define MAXLEN	 MINSEENBY
#define ONELINE  100
/**** Changed from MAXLINK to eliminate conflict with some predefined const */
#define SQW_MAXLINK  4096
/**************   ஫ 㬬 ****************************/
/*  -㭪 ᯠᨡ ࣥ 客. Honeyman's nice hashing function */
#define CRC_ADD(B,C) (((C) >> 7) ^ cr3tab[((char)(C) ^ (B)) & 0x7F])
/**************  ⫠筮  ***********************************/
#if DEBUG
#include "./_debug.h"
#else
#define Debug
#endif /* DEBUG */
/**************  ⢥  ************************************/
#define AllocCpy(A) AllocCheck(((s1-s0) + 2),A); strcpy(A,s0)

#if DEBUG

#define AllocCheck(Number,Pointer) if\
((Number) && ((Pointer = farmalloc((unsigned long)(Number) * sizeof(*Pointer))) == NULL))\
{\
printf("malloc number %lu; ", malloc_num);\
printf("%s %u %s=farmalloc(%s);\n", __FILE__, __LINE__, #Pointer, #Number);\
printf("Unsuccessfull allocate %lu bytes\n", (unsigned long)(Number));\
Errexit(Lin_Memory, Erl_Memory);\
} else if (!Number) Pointer = NULL;\
       else printf ("%lu: %s = malloc(%s = %lu, size %u);\n",\
       malloc_num++, #Pointer, #Number, (unsigned long)(Number), sizeof(*Pointer))


#define AllocCheckConst(Number,Pointer) if\
((Pointer = farmalloc((unsigned long)(Number) * sizeof(*Pointer))) == NULL)\
{\
printf("malloc number %lu; ", malloc_num);\
printf("%s %u %s=farmalloc(%s);\n", __FILE__, __LINE__, #Pointer, #Number);\
printf("Unsuccessfull allocate %lu bytes\n", (unsigned long)(Number));\
Errexit(Lin_Memory,Erl_Memory);\
} else printf ("%lu: %s = malloc(%s = %lu, size %u);\n",\
  malloc_num++, #Pointer, #Number, (unsigned long)(Number), sizeof(*Pointer))

#else /* DEBUG */

#define AllocCheckConst(Number,Pointer) if\
((Pointer = farmalloc((unsigned long)(Number) * sizeof(*Pointer))) == NULL)\
   Errexit(Lin_Memory,Erl_Memory); else

#define AllocCheck(Number,Pointer) if\
((Number) && ((Pointer = farmalloc((unsigned long)(Number) * sizeof(*Pointer))) == NULL))\
   Errexit(Lin_Memory, Erl_Memory); else if(!Number) Pointer = NULL; else

#endif

#if (AREAFIX_STYLE == 0)
#define Sqw_afix(A,B) (0)
#endif

#define SQW_SHORTEN(A) ((short int)(0x0ffffL & (A)))

#endif /* SQW_DEF_H */
