/* sqw-md.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Message Dupe Checking.	       㯮.
 * Extractin Rules.		      祭 ࠢ.
 *
 */

#include "./sqw-inc.h"

void Sqw_md(void);

/*************************** Dupe checking, rules writing ********************
Version w/o sorting dupebase	        ஢ 㯮

		    Duplicates == 0 DupeFile == 0

Table dupecheck in single file.       筠 㯮.  䠩.

		    Duplicates != 0 DupeFile == 0

Search DupeCheck in single file.      ᪮ 㯮.  䠩.

		    Duplicates != 0 DupeFile == 1

Search DupeCheck in echoarea paths.   ᪮ 㯮. 䠩.
RulesExtract  works  only  in  this   祭 ࠢ ࠡ⠥ ⮫쪮   ⮬
mode!				      ਠ!

Not implemented yet:

		    Duplicates == 0 DupeFile == 1

Table DupeCheck in echoarea paths.    筠 㯮. 䠩.
Now this combination works only as       ࠡ⠥ :

		    Duplicates == 0 DupeFile == 0

**************************** Macroses *************************************/
/* -- Treat desired message as dupe (netmail or not) ------------------- */
void Set_Dupe(unsigned int j)
{
if (Msg[j].Area == AREANET) Msg[j].Area = AREANED;
else Msg[j].Area = AREADUP;
}
/*
#define Set_Dupe(j) if (Msg[j].Area == AREANET) Msg[j].Area = AREANED;\
		    else Msg[j].Area = AREADUP
*/
/* ------------- 㭪 ࠢ MSG  qsort() based on Area -------- */
/* int arcmp(const int *i, const int *j)   뫮  */
int arcmp(const void *a, const void *b) /* ⠫ */
    {
    int *i, *j; 			/* ⠫ */
    i=(int*)a;				/* ⠫ */
    j=(int*)b;				/* ⠫ */

    if (Msg[*i].Area == Msg[*j].Area) return 0;
    else if (Msg[*i].Area > Msg[*j].Area) return 1;
	 else return -1;
    }
#if DUPETABLE
/* --- Skip items in dupetable file to next actual ---------------------- */
#define Skip_offset(k) while (offset < k)\
	{\
	fwrite (&word, sizeof(word),1,fileout);\
	if (filepkt) fread  (&word, sizeof(word),1,filepkt); else word = 0;\
	offset++;\
	}
/* ------------- 㭪 ࠢ MSG  qsort() based on MsgID high -- */
/* int idcmp(const int *i, const int *j)   뫮 */
int idcmp(const void *a, const void *b) /* ⠫ */
    {
    int *i, *j; 			/* ⠫ */
    i=(int*)a;				/* ⠫ */
    j=(int*)b;				/* ⠫ */

    if (Msg[*i].DupeID == Msg[*j].DupeID) return 0;
    else if (Msg[*i].DupeID > Msg[*j].DupeID) return 1;
	 else return -1;
    }
/* ------------- 㭪 ࠢ MSG  qsort() based on MsgID low --- */
/* int dicmp(const int *i, const int *j)   뫮 */
int dicmp(const void *a, const void *b) /* ⠫ */
    {
    int *i, *j; 			/* ⠫ */
    i=(int*)a;				/* ⠫ */
    j=(int*)b;				/* ⠫ */

    if ((Msg[*i].DupeID & 0xFFFF) == (Msg[*j].DupeID & 0xFFFF)) return 0;
    else if ((Msg[*i].DupeID & 0xFFFF) > (Msg[*j].DupeID & 0xFFFF)) return 1;
	 else return -1;
    }
#endif /* DUPETABLE */
/* ------------------------- fopen/Read Dup[Dup_Num] from path ---------- */
void FileRead(char *path)
{
if ((filepkt = fopen(sqw_ph(path),rb)) != NULL)
   {
   setvbuf(filepkt, Buf_Pkt, _IOFBF, Cfg_BufSize);
/*+###021 */
   fseek(filepkt,0L,SEEK_END);
   if (ftell(filepkt) > ((long)Cfg_Duplicates * sizeof(Dup)))
      fseek(filepkt, 0L - ((unsigned long)Cfg_Duplicates * sizeof(Dup)),SEEK_CUR);
   else rewind(filepkt);
/*-###021 */
   Dup_Num = fread((void *)Dup, sizeof(*Dup), Cfg_Duplicates, filepkt);
   if (ferror(filepkt))
	{
	sprintf (Buffer, Format_ss, path, Read_Error);
	OutLog (LEV_LOOSE, Buffer);
	}
   fclose(filepkt);
   filepkt = NULL;
   }
else Dup_Num = 0;
} /* void FileRead(char *path) */
/* ------------------------- fopen/write Dup[Dup_Num] to path ----------- */
void FileWrite(char *path)
{
if (Dup_Num) fileout = fopen(sqw_ph(path), wb); 	/* open for create/write  */
else return;					/* ###048 */
if (fileout)					/* if opened successfully */
   {
   setvbuf(fileout, Buf_Out, _IOFBF, Cfg_BufSize);
   fwrite ((void *)Dup, sizeof(*Dup), Dup_Num, fileout); /* write file	 */
   if (ferror(fileout)) 			/* if error occured	 */
	{
	sprintf (Buffer, Format_ss, path, Write_Error);
	OutLog (LEV_LOOSE, Buffer);
	}
   fclose (fileout);
   fileout = NULL;
   }
else {						/* If error on opening file */
     sprintf (Buffer, Format_ss, path, Cant_Create);
     OutLog (LEV_LOOSE, Buffer);
     }
}/* void FileWrite(char *path) */
/* ------------------------- Output of msgs, dupes numbers per area ----- */
static int	rules_error = 0,
		rules_written = 0;
static unsigned int	msgs_per_area = 0,
			dupes_per_area = 0;
static char Format_suuss[] = "%s: %u msgs %u dupes%s%s";

void out_per_area (unsigned int area, char huge *tagbegin)
{
if ((area >= AREA1ST) && (msgs_per_area || dupes_per_area))
	{
	sprintf(Buffer,Format_suuss,
		tagbegin - Area[area].Tag,
		msgs_per_area, dupes_per_area,
		(rules_error?"; Error writing rules":""),
		(rules_written?"; Rules written":""));
	OutLog (LEV_WARN,Buffer);
	puts((Buffer + Area[area].Tag + 1));
	}
else;
if ((area == AREANET) && (msgs_per_area || dupes_per_area))
	{
	sprintf(Buffer,"NETMAIL: %u msgs %u dupes",
		msgs_per_area, dupes_per_area);
	OutLog (LEV_WARN,Buffer);
	puts(Buffer);
	}
} /* out_per_area() */
/************************** main function of this module ******************/
static char Search[] = "Search ", Checking[] = "Checking... "
#if DUPETABLE
     ,Table[] = "Table ", First[] = "First ", Second[] = "Second"
#endif /* DUPETABLE */
;

void Sqw_md()
{
char Field_To[37];
char Field_From[37];
char Field_Subj[73];

char *old_xpb = sqwish_xpb,
     *old_dpb = sqwish_dpb;

char newpath[MAXPATH+3], /* What file to be written if area changed */
     oldpath[MAXPATH+3], /* what file to be readen  if area changed */
     new_xpb[MAXPATH+3],
     new_dpb[MAXPATH+3],
     *s1 = oldpath;		/* pointer in oldpath			 */
char huge *s2 = Path_Lin;	/* ⥫  ப ⥩  㯮 */
char huge *s3 = Tag_Lin;	/* ⥫  ப ⠣		 */
	 unsigned int area;	/* ⥪騩  宮		 */
register unsigned int i,j,k;	/*  稪  ࠧ 楫	 */
		  int duplast=0;/*  ⠬   ᫥ 㯠?  */

#if (DEBUG == 3)
/**/	printf ("Sqw_md() beginning; 16 areapaths:\n");
/**/	{ char *s0 = (char *)Path_Lin;
/**/	for (i = 0; i < 16; i++)
/**/		{
/**/		printf ("%s\t", s0);
/**/		s0 += Area[i].Path;
/**/		}
/**/	printf ("Press Enter to continue>");
/**/	getchar(); printf ("\n");
/**/	}
#endif
 for (i = 0; i < MSG_Num; i++) Msg_Tab[i] = i; /* 樠 ⠡窨 */
 if (Cfg_DupeFile) qsort ((int *)Msg_Tab, MSG_Num, sizeof(int), arcmp);

/* ---------------------------------------------------------------------------
   Now	message  table is sorted by     ⠡窠 ᮮ饭 ஢
   area -  it causes to read/check/    宮 -     /
   write  every area dupebase once,    㯮   ,
   with checking messages in sorted   ॡ ᫥⥫쭮  ஢-
   order.			       ᮮ饭.
   ------------------------------------------------------------------------- */

/****************** Search checking ******************************************/
if (Cfg_Duplicates)
 {
 OutLog2 (LEV_TRIV, Search, Checking);
 fputs (Search, stdout); puts(Checking);
 FileRead (sqwish_dpb); 		/* ⠫ 㯮   */
/*========================= ᭮ 横 ᬮ ᮮ饭 ==========*/
 area = AREANET;			/*  㯮  । */
					/*   - sqwish.dpb	  */

/*    㯮   ४ਨ 䫠 */
 sprintf(new_xpb,Format_ss,FlagD,old_xpb); sqwish_xpb=new_xpb;
 sprintf(new_dpb,Format_ss,FlagD,old_dpb); sqwish_dpb=new_dpb;

 strcpy(oldpath, sqwish_xpb);
 strcpy(newpath, sqwish_xpb); /* ###023 */

 for (k = 0; k < MSG_Num; k++)
    {
    i = Msg_Tab[k];
    if (!Cfg_NetDupes && (Msg[i].Area < AREA1ST))
       continue; else;			/*   -?	*/
    if (Cfg_NetDupes && (Msg[i].Area < AREA1ST) && (Msg[i].Area != AREANET))
       continue; else;			/*   ᫨  ...	*/
    if (Cfg_DupeFile && (area != Msg[i].Area))
	{				/* ᫨   䠩 㯮	*/
					/* ᬥ ⥪ 	*/
	out_per_area(area, s3);
	msgs_per_area = 0;
	dupes_per_area = 0;
	rules_written = 0;
	rules_error = 0;
	while (++area < Msg[i].Area)	/*  㦭  	*/
		{
		s2 += Area[area].Path;	/* 񫪠 㪠⥫  	*/
		s3 += Area[area].Tag;	/*   ⠣ 		*/
		}
	printf ("%s: ", s3);
	s3 += Area[area].Tag;		/* ⠢ -  ᫥. ⠣ */
	s1 = newpath;			/* ᪮஢   䠩	  */
	for (j = 0; j < Area[area].Path; j++) *s1++ = *s2++;
	sprintf (s1-1, ".~%c%c", Qq, Ww);       /*  ७  */
	if ((fileout = fopen(sqw_ph(newpath),wb)) == NULL)
	     {					/*   ᮧ	  */
	     if (strcmp(oldpath,sqwish_xpb))	/*    ।騩?*/
		{				/* ।騩 -  .~PB   */
		FileWrite(oldpath);		/* 뢠 ।騩  */
		FileRead(sqwish_xpb);		/*  㤠筨 襬   */
		strcpy (oldpath,sqwish_xpb);	/* ~PB    */
		}
	     else; /* ।騩 - sqwish.~pb,    㫨  ⠪ */
	     } /* if fopen newpath.~QW == NULL	*/
	else {				/* ᮧ 䠩  ⠪  */
	     fclose (fileout);		/*  뢠 ⮡		 */
	     fileout = NULL;
	     remove (newpath);		/* ࠧ   䨣 	 */
	     FileWrite(oldpath);	/* 뢠 ।騩 䠩	 */
	     *s1 = Ss;			/* ⥯ ⠥ .SQW		 */
	     FileRead(newpath); 	/*   			 */
	     *s1 = '~';                 /* 塞 ७  .~QW   */
	     strcpy(oldpath, newpath);	/* ।騩  ⥯   */
					/*   ⥪騩.		 */
	     } /* else fopen newpath.~QW == NULL */
	} /* if DupeFile && area != */
    msgs_per_area++;
    if (Msg[i].DupeID != Dup[duplast])	/*   ᮢ  ।騬?  */
    /*********  ᮢ饣  ॡ஬  ஢ */
	for (j = 0; j < Dup_Num; j++) if (Msg[i].DupeID == Dup[j]) break; else;
    else j=duplast;
    if (j < Dup_Num)			/* ᫨  ⠪ ID...	 */
	 {
	 if (Msg[i].Area == AREANET)	/*  		 */
	      {
	      Msg[i].Area = AREANED;
	      dupes_per_area++;
	      duplast = j;		/*  ⭠ 窠 -*/
	      } 			/*  ᥬ 		 */
	 else {
	      if (Area[Msg[i].Area].killDupes) Msg[i].Area = AREAKIL;
	      else Msg[i].Area = AREADUP;
	      dupes_per_area++;
	      duplast = j+1;		/*  宬 ⭥, */
					/*    ᫥⥫-*/
	      } 			/*  ᠣ,  duplast 㪠-*/
					/*   ᫥ ᠣ	 */
	 }
    else {
	 if (Dup_Num >= (unsigned int)Cfg_Duplicates)
					/* ᫨ 㯮  ᨬ㬠	 */
		{			/* ᤢ   砫 	 */
		Dup_Num -= DUPSTEP;
		if (duplast >= DUPSTEP) duplast -= DUPSTEP; else duplast = 0;
		for (j = 0; j < Dup_Num; j++) Dup[j]=Dup[j+DUPSTEP];
		}
	 else;
	 Dup[Dup_Num++]=Msg[i].DupeID;
/*------------------------ Rules Extracting section -------------------------*/
	 if (Cfg_RulesExtract && Msg[i].rule)
		{ unsigned long l;
/*+###064 */
		static char prevSubj[73] = { '\0' };
		static int  rulesParts = 0;
		static int  prevArea = 0;
/*-###064 */
		char *openfile = wt;
		l = Msg[i].Length - sizeof(mh) - Msg[i].LTo -
			Msg[i].LFrom - Msg[i].LSubj - 2;
		if (l > MINSEENBY)
		  {
		  sprintf(Buffer,"%lub size of Rules' message, too large.", l);
		  OutLog(LEV_POSSIBLE,Buffer);
		  }
		else
		  {
		  filepkt = fopen(PKTFile[Msg[i].PKT],rb);
		  if (filepkt == NULL)
		     OutLog2(LEV_POSSIBLE, PKTFile[Msg[i].PKT],Read_Error);
		  else	{
			fseek(filepkt, Msg[i].Offset, SEEK_SET);
			hline((void *)&mh, (size_t)sizeof(mh));
			hline(Field_To,Msg[i].LTo);
			hline(Field_From,Msg[i].LFrom);
			hline(Field_Subj,Msg[i].LSubj);
/*+###064 */
			if ((!Cfg_RulesParts) ||
			    (area != prevArea) ||
			    (Cfg_RulesParts &&
			     (rulesParts < Cfg_RulesParts) &&
			     (stricmp(Field_Subj, prevSubj))
			    )
			   )
			  {
			  if (area == prevArea)
			     {
			     openfile = at;
			     strcpy(prevSubj, Field_Subj);
			     rulesParts++;
			     }
			  else
			     {
			     openfile = wt;
			     strcpy(prevSubj, empty);
			     rulesParts = 0;
			     prevArea = area;
			     }
/*-###064 */
			  sprintf(Buffer,"*%s*", s3-Area[area].Tag); /*###042 */
			  if ((!Area[area].MatchTag) ||
				(strcasecmp_match(Field_From,Buffer) == 0) ||
				(strcasecmp_match(Field_Subj,Buffer) == 0))
			    {
/* ७ 䠩 RUL */  strcpy(s1,Rul);
/*   ⥪ */     fileout = fopen(sqw_ph(newpath),openfile);
			    if (fileout != NULL)
/*<----------------------------{ */
{
if (fread(Buffer,1,(size_t)l,filepkt) != (size_t)l)/* Read message body */
   OutLog2(LEV_POSSIBLE,PKTFile[Msg[i].PKT],Read_Error);
else
   { char *s0; char crlftok[] = "\r\n";
   Buffer[(unsigned int)l] = '\0';
   fprintf(fileout, "From: %s\nTo: %s\nSubj: %s\n\n",
	Field_From, Field_To, Field_Subj);
   s0 = strtok(Buffer,crlftok);
   do	{
	if (s0 == NULL) break; else;
	if (*s0 == '\001') *s0 = '@'; else;     /* Invalidate kludges        */
	if (strcasecmp_match(s0, "---*") == 0)  /* Invalidate tearline       */
		s0[1] = '+'; else;
	if (strcasecmp_match(s0, " ? Origin:*") == 0)   /* Invalidate origin */
		s0[1] = '!'; else;
	if ((strcasecmp_match(s0, "AREA:*") == 0) ||    /* Invalidate AREA:  */
	    (strcasecmp_match(s0, "SEEN?BY:*") == 0))   /* Invalidate SEEN-BY*/
	     fputc('@',fileout); else;
	fprintf(fileout, Format_sn, s0);
	s0 = strtok(NULL,crlftok);
	}
   while (s0 != NULL);
   if (ferror(fileout)) rules_error = 1;
   else rules_written = 1;
   fclose(fileout);
   fileout = NULL;
   } /* else fread != l */
} /* if fileout */
/*}----------------------------} */
			    else rules_error = 1;
			    sprintf(s1,"~%c%c", Qq, Ww);
			    } /* if !MatchTag, strcasecmp... */
/*+###064 */
			  } /* if different subjes & rulesParts not exceeded */
			else {
			     openfile = wt;
			     strcpy(prevSubj, empty);
			     rulesParts = 0;
			     prevArea = area;
			     }

/*-###064 */
			fclose(filepkt);
			filepkt = NULL;/* ###051 */
			} /* else filepkt == NULL */
		  } /* else l > MINSEENBY */
		} /* if Cfg_RulesExtract */
	 else;
/*--------------------- end of rules extracting section ---------------------*/
	 } /* else j < Dup_Num */
    } /* for k < MSG_Num */
 if (Cfg_DupeFile) out_per_area(area, s3);
/*========================  稢襩 㯮 =====================*/
 if (!Cfg_DupeFile) strcpy(newpath,sqwish_xpb);
 FileWrite (newpath);
 if (!Cfg_DupeFile) OutLog (LEV_TRIV, "Writing temporary dupebase");
 } /* if Duplicates */
#if DUPETABLE
else
 {
/*======================== Table checking dupeboard =========================*
Main logic of this process is:	      ᭮   ⠪:

Msg DupeID is read from  sorted  by   㯮筠 ଠ ᠣ (  -
it's high part table in memory, and   ) ⠥  ஢   -
next  portion  of table dupefile is   襩  ⠡窨,    ।  
read to offset, proportional to va-   䠩  㯮	⠥    ᬥ饭,
lue of Msg DupeId high	part.  Word   ய樮쭮 襩  .  -
is read from dupefile at this  off-   ⠭  ⮣ ᬥ饭 ᫮ ࠢ-
set and is compared with  low  part     襩  .  - ᫨ 
of Msg DupeId info. If this word is   䠩 ⮨ 0 - ᠣ 㯮 	-
zero - message isn't the  dupe, and   ,     ⮣    뢠
Msg DupeId low part is	written  in   祭 襩  . ᫨ ᫮ -
new dupefile at this offset. If the    - ᠣ ⠥  㯮.  ᫨  
words are equal - message is inter-   ࠢ -  ࠭ ஥ 祭
preted as dupe. If  words  are	not   襩  ,   .
equal - old dupe low part  value is
kept here.			      ன 室 ࠪ᪨ 祭 -
				      ,  ᬥ饭  㯮䠩   
The second pass is nearly analogous   襩  ,   ⠭  䠩-
to the first, but offset in dupefi-    ᫮ ࠢ    .
le is according to low part of	Msg
DupeId, and high part  is  compared   㣮 ⫨稥 ண 室 ⮨  
with word read from  dupefile.	The   ⮬,   ᮢ  ஥  -
other difference is: if message  is   祭  㯮䠩 ࠥ .  
not interpreted as dupe - it's info    ⠪ 﫨  ६.
rewrites old dupeid word in new du-
pefile.
				       䠩 㯮  ⮬ ﭨ -
So - size of dupefile in this  mode   256 .   ⥭/ 
is 256 Kb. Read/Write process takes    ६,  ᨬ   -
the same time regardless  from	the   ⢠ ࠡ뢠 ᮮ饭. -
amount of tossed messages. So - the    让 ᨭ  ⢥ -
large tossing is  faster  if  table   ॥  ⠡筮 㯮,   -
dupechecking is choosen, but  small   ⢮ ᠣ 	  ⮬  砥
amount of messages is tossed slower    .
in this case.

Maximum summary amount	of dupeinfo   ᨬ쭮 㬬୮ ⢮ -
items is 128K.			      ⮢ ⠪ 㯮 - 128.
-----------------------------------------------------------------------------*/

 signed long offset;
 unsigned long Overrides = 0;
 unsigned int  word=0, k, l;

/*    㯮   ४ਨ 䫠 */
 sprintf(new_xpc,Format_ss,FlagD,old_xpc); sqwish_xpc=new_xpc;
 sprintf(new_dpc,Format_ss,FlagD,old_dpc); sqwish_dpc=new_dpc;

 filepkt = fopen(sqwish_dpc,rb);
 setvbuf(filepkt, Buf_Pkt, _IOFBF, Cfg_BufSize);
 fileout = fopen(sqwish_xpc,wb);
 setvbuf(fileout, Buf_Out, _IOFBF, Cfg_BufSize);
 OutLog2 (LEV_TRIV, Table, Checking);
 printf(Format_ss, Table, Checking);
 for (i = 0; i < MSG_Num; i++) Msg_Tab[i] = i; /* 樠 ⠡窨 */
/******************* First Table dupechecking loop ***********************/
 qsort ((int *)Msg_Tab, MSG_Num, sizeof(int), dicmp);
 word = 0;
 if (filepkt) fread(&word,sizeof(word),1,filepkt);
 for (i = 0, offset = 0; i < MSG_Num; i++)
     {
     j = Msg_Tab[i];
     if ((Msg[j].Area > AREANET) && (Msg[j].Area < AREA1ST)) continue; else;
     if ((Msg[j].Area == AREANET) && (!Cfg_NetDupes)) continue; else;
     k = (int)(Msg[j].DupeID & 0x0000FFFF);
     l = (int)(Msg[j].DupeID >> 16);
     Skip_offset(k);
     if (word == l) Set_Dupe(j);
     else if (word == 0) word = l;
	  else Overrides++;
     } /* for i < MSG_Num */
 Skip_offset(65536L);
/****************** Second table dupechecking loop **********************/
 OutLog (LEV_TRIV, Second); fputs(Second, stdout);
 qsort ((int *)Msg_Tab, MSG_Num, sizeof(int), idcmp);
 for (i = 0, offset = 0; i < MSG_Num; i++)
     {
     j = Msg_Tab[i];
     if ((Msg[j].Area > AREANET) && (Msg[j].Area < AREA1ST)) continue; else;
     if ((Msg[j].Area == AREANET) && (!Cfg_NetDupes)) continue; else;
     k = (int)(Msg[j].DupeID >> 16);
     l = (int)(Msg[j].DupeID & 0x0000FFFF);
     Skip_offset(k);
     if (word == l) Set_Dupe(j);
     else {if (word) Overrides++; else; word = l;}
     } /* for i < MSG_Num */
 Skip_offset(65536L);
 fwrite (&word, sizeof(word),1,fileout);

  { char *tmp = "%lu replaced dupes";
  if (Overrides) printf(tmp,Overrides); else;
  fputc('\n', stdout);
  LogOut(1,fprintf(Log_file,tmp,Overrides));
  }

 if (filepkt) fclose (filepkt);
 fclose (fileout);
 filepkt = NULL;
 fileout = NULL;
/************************************************************************/
 } /* else Duplicates */
sqwish_xpc=old_xpc; /*  ப sqwish_xpc, sqwish_dpc ᪮ */
sqwish_dpc=old_dpc; /* 祭 */
#endif /* DUPETABLE */
sqwish_xpb=old_xpb; /*  ப sqwish_xpb, sqwish_dpb ᪮ */
sqwish_dpb=old_dpb; /* 祭 */
} /* Sqw_md() */
